"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FormatIcon = exports.ActionButton = void 0;
const compass_components_1 = require("@mongodb-js/compass-components");
const compass_components_2 = require("@mongodb-js/compass-components");
const compass_components_3 = require("@mongodb-js/compass-components");
const react_1 = __importStar(require("react"));
const actionButtonStyle = (0, compass_components_2.css)({
    flex: 'none',
});
const actionButtonContentStyle = (0, compass_components_2.css)({
    position: 'relative',
});
const actionButtonIconContainerStyle = (0, compass_components_2.css)({
    opacity: 1,
    width: 14,
    height: 14,
    transition: 'opacity .2s linear',
});
const actionButtonIconContainerHiddenStyle = (0, compass_components_2.css)({
    opacity: 0,
});
const actionButtonClickResultIconStyle = (0, compass_components_2.css)({
    position: 'absolute',
    width: 14,
    height: 14,
    top: 0,
    pointerEvents: 'none',
    opacity: 1,
    transition: 'opacity .2s linear',
});
const actionButtonClickResultIconHiddenStyle = (0, compass_components_2.css)({
    opacity: 0,
});
const ActionButton = ({ label, icon, onClick, ...props }) => {
    const [clickResult, setClickResult] = (0, react_1.useState)('success');
    const [clickResultVisible, setClickResultVisible] = (0, react_1.useState)(false);
    const onButtonClick = (0, react_1.useCallback)((...args) => {
        const result = onClick?.(...args);
        if (typeof result === 'boolean') {
            setClickResult(result ? 'success' : 'error');
            setClickResultVisible(true);
        }
    }, [onClick]);
    (0, react_1.useEffect)(() => {
        if (!clickResultVisible) {
            return;
        }
        const timeoutId = setTimeout(() => {
            setClickResultVisible(false);
        }, 1000);
        return () => {
            clearTimeout(timeoutId);
        };
    }, [clickResultVisible]);
    return (react_1.default.createElement(compass_components_3.Button, { size: "xsmall", "aria-label": label, title: label, onClick: onButtonClick, className: actionButtonStyle, "data-testid": props['data-testid'] ?? `editor-action-${label}` },
        react_1.default.createElement("div", { className: actionButtonContentStyle },
            react_1.default.createElement("div", { className: (0, compass_components_1.cx)(actionButtonIconContainerStyle, clickResultVisible && actionButtonIconContainerHiddenStyle) }, typeof icon === 'string' ? (react_1.default.createElement(compass_components_3.Icon, { size: "small", role: "presentation", title: null, glyph: icon })) : (icon)),
            react_1.default.createElement("div", { className: (0, compass_components_1.cx)(actionButtonClickResultIconStyle, !clickResultVisible && actionButtonClickResultIconHiddenStyle) },
                react_1.default.createElement(compass_components_3.Icon, { size: "small", glyph: clickResult === 'success' ? 'Checkmark' : 'X' })))));
};
exports.ActionButton = ActionButton;
const FormatIcon = ({ size = 16, ...props }) => (react_1.default.createElement("svg", { xmlns: "http://www.w3.org/2000/svg", fill: "none", width: size, height: size, viewBox: "0 0 16 16", ...props },
    react_1.default.createElement("path", { fill: "currentColor", d: "M2 4a1 1 0 0 1 1-1h2a1 1 0 1 1 0 2H3a1 1 0 0 1-1-1Zm0 4a1 1 0 0 1 1-1h6a1 1 0 1 1 0 2H3a1 1 0 0 1-1-1Zm1 3a1 1 0 1 0 0 2h10a1 1 0 1 0 0-2H3Zm4-7a1 1 0 0 1 1-1h5a1 1 0 1 1 0 2H8a1 1 0 0 1-1-1Zm4 4a1 1 0 0 1 1-1h1a1 1 0 1 1 0 2h-1a1 1 0 0 1-1-1Z" })));
exports.FormatIcon = FormatIcon;
//# sourceMappingURL=actions.js.map