"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createQueryAutocompleter = void 0;
const autocompleter_1 = require("../autocompleter");
const ace_compat_autocompleter_1 = require("./ace-compat-autocompleter");
const utils_1 = require("./utils");
const createQueryAutocompleter = (options = {}) => {
    const completions = (0, autocompleter_1.completer)('', {
        meta: ['query', 'bson', 'field:identifier'],
        ...options,
    });
    return (0, ace_compat_autocompleter_1.createAceCompatAutocompleter)({
        String({ context }) {
            return (0, utils_1.completeWordsInString)(context);
        },
        IdentifierLike({ prefix }) {
            return (0, ace_compat_autocompleter_1.createCompletionResultForIdPrefix)({ prefix, completions });
        },
    });
};
exports.createQueryAutocompleter = createQueryAutocompleter;
//# sourceMappingURL=query-autocompleter.js.map