"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getCodemirrorEditorValue = exports.setCodemirrorEditorValue = exports.CodemirrorMultilineEditor = exports.CodemirrorInlineEditor = exports.BaseEditor = exports.languageName = exports.languages = exports.editorPalette = void 0;
const react_1 = __importStar(require("react"));
const view_1 = require("@codemirror/view");
const language_1 = require("@codemirror/language");
const commands_1 = require("@codemirror/commands");
const lint_1 = require("@codemirror/lint");
const autocomplete_1 = require("@codemirror/autocomplete");
const compass_components_1 = require("@mongodb-js/compass-components");
const lang_javascript_1 = require("@codemirror/lang-javascript");
const lang_json_1 = require("@codemirror/lang-json");
const state_1 = require("@codemirror/state");
const language_2 = require("@codemirror/language");
const highlight_1 = require("@lezer/highlight");
const polished_1 = require("polished");
const prettify_1 = require("./prettify");
const actions_1 = require("./actions");
const editorStyle = (0, compass_components_1.css)({
    fontSize: 13,
    fontFamily: compass_components_1.fontFamilies.code,
});
const hiddenScrollStyle = (0, compass_components_1.css)({
    '& .cm-scroller': {
        overflow: '-moz-scrollbars-none',
        msOverflowStyle: 'none',
    },
    '& .cm-scroller::-webkit-scrollbar': {
        display: 'none',
    },
});
function isReadOnly(state) {
    return state.facet(state_1.EditorState.readOnly);
}
const tabKeymap = [
    {
        key: 'Tab',
        run(context) {
            if (isReadOnly(context.state)) {
                return false;
            }
            return (0, autocomplete_1.acceptCompletion)(context);
        },
    },
    {
        key: 'Tab',
        run({ state, dispatch }) {
            if (isReadOnly(state)) {
                return false;
            }
            if (!state.selection.ranges.some((range) => !range.empty)) {
                dispatch(state.update(state.replaceSelection('\t'), {
                    scrollIntoView: true,
                    userEvent: 'input',
                }));
                return true;
            }
            return false;
        },
    },
    commands_1.indentWithTab,
];
exports.editorPalette = {
    light: {
        color: compass_components_1.codePalette.light[3],
        backgroundColor: compass_components_1.codePalette.light[0],
        gutterColor: compass_components_1.codePalette.light[3],
        gutterBackgroundColor: compass_components_1.codePalette.light[0],
        gutterActiveLineBackgroundColor: (0, polished_1.rgba)(compass_components_1.palette.gray.light2, 0.5),
        gutterFoldButtonColor: compass_components_1.palette.black,
        cursorColor: compass_components_1.palette.gray.base,
        activeLineBackgroundColor: (0, polished_1.rgba)(compass_components_1.palette.gray.light2, 0.5),
        selectionBackgroundColor: compass_components_1.palette.blue.light2,
        bracketBorderColor: compass_components_1.palette.gray.light1,
        infoGutterIconColor: encodeURIComponent(compass_components_1.palette.blue.base),
        warningGutterIconColor: encodeURIComponent(compass_components_1.palette.yellow.base),
        errorGutterIconColor: encodeURIComponent(compass_components_1.palette.red.base),
        foldPlaceholderColor: compass_components_1.palette.gray.base,
        foldPlaceholderBackgroundColor: compass_components_1.palette.gray.light3,
        autocompleteColor: compass_components_1.palette.black,
        autocompleteBackgroundColor: compass_components_1.palette.gray.light3,
        autocompleteBorderColor: compass_components_1.palette.gray.light2,
        autocompleteMatchColor: compass_components_1.palette.green.dark1,
        autocompleteSelectedBackgroundColor: compass_components_1.palette.gray.light2,
    },
    dark: {
        color: compass_components_1.codePalette.dark[3],
        backgroundColor: compass_components_1.codePalette.dark[0],
        gutterColor: compass_components_1.codePalette.dark[3],
        gutterBackgroundColor: compass_components_1.codePalette.dark[0],
        gutterActiveLineBackgroundColor: (0, polished_1.rgba)(compass_components_1.palette.gray.dark2, 0.5),
        gutterFoldButtonColor: compass_components_1.palette.white,
        cursorColor: compass_components_1.palette.green.base,
        activeLineBackgroundColor: (0, polished_1.rgba)(compass_components_1.palette.gray.dark2, 0.5),
        selectionBackgroundColor: compass_components_1.palette.gray.dark2,
        bracketBorderColor: compass_components_1.palette.gray.light1,
        infoGutterIconColor: encodeURIComponent(compass_components_1.palette.blue.light1),
        warningGutterIconColor: encodeURIComponent(compass_components_1.palette.yellow.light2),
        errorGutterIconColor: encodeURIComponent(compass_components_1.palette.red.light1),
        foldPlaceholderColor: compass_components_1.palette.gray.base,
        foldPlaceholderBackgroundColor: compass_components_1.palette.gray.dark3,
        autocompleteColor: compass_components_1.palette.gray.light1,
        autocompleteBackgroundColor: compass_components_1.palette.gray.dark4,
        autocompleteBorderColor: compass_components_1.palette.gray.dark1,
        autocompleteMatchColor: compass_components_1.palette.gray.light3,
        autocompleteSelectedBackgroundColor: compass_components_1.palette.gray.dark2,
    },
};
const cmFontStyles = {
    fontSize: '13px',
    fontFamily: compass_components_1.fontFamilies.code,
};
function getStylesForTheme(theme) {
    return view_1.EditorView.theme({
        '&': {
            color: exports.editorPalette[theme].color,
            backgroundColor: exports.editorPalette[theme].backgroundColor,
            maxHeight: '100%',
        },
        '& .cm-scroller': cmFontStyles,
        '&.cm-editor.cm-focused': {
            outline: 'none',
        },
        '& .cm-content': {
            paddingTop: `${compass_components_1.spacing[1]}px`,
            paddingBottom: `${compass_components_1.spacing[1]}px`,
            caretColor: exports.editorPalette[theme].cursorColor,
        },
        '& .cm-activeLine': {
            background: 'none',
        },
        '&.cm-focused .cm-activeLine': {
            backgroundColor: exports.editorPalette[theme].activeLineBackgroundColor,
        },
        '& .cm-gutters': {
            color: exports.editorPalette[theme].gutterColor,
            backgroundColor: exports.editorPalette[theme].gutterBackgroundColor,
            border: 'none',
        },
        '& .cm-gutter-lint': {
            width: `${compass_components_1.spacing[3]}px`,
        },
        '& .cm-gutter-lint .cm-gutterElement': {
            padding: '0',
        },
        '& .cm-gutter-lint .cm-lint-marker': {
            width: `${compass_components_1.spacing[3]}px`,
            height: `${compass_components_1.spacing[3]}px`,
            padding: '2px',
        },
        '& .cm-gutter-lint .cm-lint-marker-info': {
            content: `url("data:image/svg+xml,%3Csvg xmlns='http://www.w3.org/2000/svg' fill='none' viewBox='0 0 16 16'%3E%3Cpath fill='${exports.editorPalette[theme].infoGutterIconColor}' fill-rule='evenodd' d='M8 15A7 7 0 1 0 8 1a7 7 0 0 0 0 14ZM9 4a1 1 0 1 1-2 0 1 1 0 0 1 2 0ZM8 6a1 1 0 0 1 1 1v4h.5a.5.5 0 0 1 0 1h-3a.5.5 0 0 1 0-1H7V7h-.5a.5.5 0 0 1 0-1H8Z' clip-rule='evenodd'/%3E%3C/svg%3E%0A")`,
        },
        '& .cm-gutter-lint .cm-lint-marker-warning': {
            content: `url("data:image/svg+xml,%3Csvg xmlns='http://www.w3.org/2000/svg' fill='none' viewBox='0 0 16 16'%3E%3Cpath fill='${exports.editorPalette[theme].warningGutterIconColor}' fill-rule='evenodd' d='M8.864 2.514a.983.983 0 0 0-1.728 0L1.122 13.539A.987.987 0 0 0 1.986 15h12.028a.987.987 0 0 0 .864-1.461L8.864 2.514ZM7 6a1 1 0 0 1 2 0v4a1 1 0 1 1-2 0V6Zm2 7a1 1 0 1 1-2 0 1 1 0 0 1 2 0Z' clip-rule='evenodd'/%3E%3C/svg%3E%0A")`,
        },
        '& .cm-gutter-lint .cm-lint-marker-error': {
            content: `url("data:image/svg+xml,%3Csvg xmlns='http://www.w3.org/2000/svg' fill='none' viewBox='0 0 16 16'%3E%3Cpath fill='${exports.editorPalette[theme].errorGutterIconColor}' fill-rule='evenodd' d='M8 15A7 7 0 1 0 8 1a7 7 0 0 0 0 14zm1.414-9.828a1 1 0 1 1 1.414 1.414L9.414 8l1.414 1.414a1 1 0 1 1-1.414 1.414L8 9.414l-1.414 1.414a1 1 0 1 1-1.414-1.414L6.586 8 5.172 6.586a1 1 0 0 1 1.414-1.414L8 6.586l1.414-1.414z' clip-rule='evenodd'/%3E%3C/svg%3E%0A")`,
        },
        '& .cm-activeLineGutter': {
            background: 'none',
        },
        '&.cm-focused .cm-activeLineGutter': {
            backgroundColor: exports.editorPalette[theme].gutterActiveLineBackgroundColor,
        },
        '& .cm-foldPlaceholder': {
            display: 'inline-block',
            border: 'none',
            color: exports.editorPalette[theme].foldPlaceholderColor,
            backgroundColor: exports.editorPalette[theme].foldPlaceholderBackgroundColor,
            boxShadow: `inset 0 0 0 1px ${exports.editorPalette[theme].foldPlaceholderColor}`,
            padding: '0 2px',
        },
        '& .foldMarker': {
            width: `${compass_components_1.spacing[3]}px`,
            height: `${compass_components_1.spacing[3]}px`,
            display: 'flex',
            alignItems: 'center',
            justifyContent: 'center',
            cursor: 'pointer',
        },
        '& .foldMarker > svg': {
            width: '12px',
            height: '12px',
            display: 'block',
            color: exports.editorPalette[theme].gutterFoldButtonColor,
        },
        '& .cm-selectionBackground': {
            backgroundColor: exports.editorPalette[theme].selectionBackgroundColor,
        },
        '&.cm-focused .cm-selectionBackground, ::selection': {
            backgroundColor: exports.editorPalette[theme].selectionBackgroundColor,
        },
        '&.cm-focused .cm-matchingBracket': {
            background: 'none',
            boxShadow: `0 0 0 1px ${exports.editorPalette[theme].bracketBorderColor}`,
            borderRadius: '2px',
        },
        '& .cm-selectionBackground:first-child': {
            borderTopLeftRadius: '3px',
            borderTopRightRadius: '3px',
        },
        '& .cm-selectionBackground:last-child': {
            borderBottomLeftRadius: '3px',
            borderBottomRightRadius: '3px',
        },
        '& .cm-cursor': {
            borderLeft: '2px solid',
            borderColor: exports.editorPalette[theme].cursorColor,
            marginLeft: '-1px',
        },
        '& .cm-tooltip': {
            ...cmFontStyles,
            color: exports.editorPalette[theme].autocompleteColor,
            backgroundColor: exports.editorPalette[theme].autocompleteBackgroundColor,
            border: `1px solid ${exports.editorPalette[theme].autocompleteBorderColor}`,
        },
        '& .cm-tooltip.cm-tooltip-autocomplete > ul': {
            fontFamily: compass_components_1.fontFamilies.code,
        },
        '& .cm-tooltip-autocomplete ul li[aria-selected]': {
            color: exports.editorPalette[theme].autocompleteColor,
            backgroundColor: exports.editorPalette[theme].autocompleteSelectedBackgroundColor,
        },
        '& .cm-completionIcon': {
            display: 'none',
        },
        '& .cm-completionDetail': {
            color: (0, polished_1.rgba)(exports.editorPalette[theme].autocompleteColor, 0.5),
            fontStyle: 'normal',
            marginRight: '1em',
        },
        '& .cm-completionMatchedText': {
            color: exports.editorPalette[theme].autocompleteMatchColor,
            fontWeight: 'bold',
            textDecoration: 'none',
        },
        '& .cm-tooltip .completion-info p': {
            margin: 0,
            marginTop: `${compass_components_1.spacing[2]}px`,
            marginBottom: `${compass_components_1.spacing[2]}px`,
        },
        '& .cm-tooltip .completion-info p:first-child': {
            marginTop: 0,
        },
        '& .cm-tooltip .completion-info p:last-child': {
            marginBottom: 0,
        },
        '& .cm-widgetBuffer': {
            verticalAlign: 'top',
        },
    }, { dark: theme === 'dark' });
}
const themeStyles = {
    light: getStylesForTheme('light'),
    dark: getStylesForTheme('dark'),
};
function getHighlightStyleForTheme(theme) {
    return language_2.HighlightStyle.define([
        {
            tag: [
                highlight_1.tags.null,
                highlight_1.tags.controlKeyword,
                highlight_1.tags.operatorKeyword,
                highlight_1.tags.definitionKeyword,
                highlight_1.tags.moduleKeyword,
                highlight_1.tags.keyword,
                highlight_1.tags.modifier,
            ],
            color: compass_components_1.codePalette[theme][10],
        },
        {
            tag: [highlight_1.tags.number, highlight_1.tags.bool, highlight_1.tags.function(highlight_1.tags.variableName), highlight_1.tags.regexp],
            color: compass_components_1.codePalette[theme][9],
        },
        {
            tag: [highlight_1.tags.string, highlight_1.tags.special(highlight_1.tags.string)],
            color: compass_components_1.codePalette[theme][7],
            fontWeight: 600,
        },
        {
            tag: [highlight_1.tags.meta],
            color: compass_components_1.codePalette[theme][6],
        },
        {
            tag: [highlight_1.tags.propertyName, highlight_1.tags.atom, highlight_1.tags.self],
            color: compass_components_1.codePalette[theme][5],
        },
        {
            tag: [
                highlight_1.tags.separator,
                highlight_1.tags.squareBracket,
                highlight_1.tags.brace,
                highlight_1.tags.variableName,
                highlight_1.tags.definition(highlight_1.tags.variableName),
                highlight_1.tags.updateOperator,
                highlight_1.tags.arithmeticOperator,
                highlight_1.tags.logicOperator,
                highlight_1.tags.bitwiseOperator,
                highlight_1.tags.compareOperator,
                highlight_1.tags.function(highlight_1.tags.punctuation),
                highlight_1.tags.punctuation,
                highlight_1.tags.paren,
                highlight_1.tags.derefOperator,
            ],
            color: compass_components_1.codePalette[theme][3],
        },
        {
            tag: [highlight_1.tags.lineComment, highlight_1.tags.blockComment],
            color: compass_components_1.codePalette[theme][2],
            fontStyle: 'italic',
        },
    ], { themeType: theme });
}
const highlightStyles = {
    light: getHighlightStyleForTheme('light'),
    dark: getHighlightStyleForTheme('dark'),
};
function createFoldGutterExtension() {
    return (0, language_1.foldGutter)({
        markerDOM(open) {
            const marker = document.createElement('span');
            marker.className = `foldMarker foldMarker${open ? 'Open' : 'Closed'}`;
            marker.ariaHidden = 'true';
            marker.title = open ? 'Fold code block' : 'Unfold code block';
            marker.innerHTML = open
                ? `<svg xmlns="http://www.w3.org/2000/svg" fill="none" viewBox="0 0 16 16"><path fill="currentColor" d="M8.679 10.796a.554.554 0 0 1-.858 0L4.64 6.976C4.32 6.594 4.582 6 5.069 6h6.362c.487 0 .748.594.43.976l-3.182 3.82z"/></svg>`
                : `<svg xmlns="http://www.w3.org/2000/svg" fill="none" viewBox="0 0 16 16"><path fill="currentColor" d="M10.796 7.321a.554.554 0 0 1 0 .858l-3.82 3.181c-.382.319-.976.058-.976-.429V4.57c0-.487.594-.748.976-.43l3.82 3.182z"/></svg>`;
            return marker;
        },
    });
}
const javascriptExpression = lang_javascript_1.javascriptLanguage.configure({
    top: 'SingleExpression',
});
exports.languages = {
    json: lang_json_1.json,
    javascript: lang_javascript_1.javascript,
    'javascript-expression': () => {
        return new language_2.LanguageSupport(javascriptExpression);
    },
};
exports.languageName = state_1.Facet.define({});
async function wait(ms) {
    return new Promise((resolve) => {
        setTimeout(resolve, ms);
    });
}
async function waitUntilEditorIsReady(editorView, signal) {
    while (editorView.updateState !== 0) {
        if (signal?.aborted) {
            return false;
        }
        await wait();
    }
    return true;
}
async function scheduleDispatch(editorView, transactions, signal) {
    await waitUntilEditorIsReady(editorView, signal);
    transactions = Array.isArray(transactions) ? transactions : [transactions];
    editorView.dispatch(...transactions);
    return true;
}
function useCodemirrorExtensionCompartment(fn, value, editorViewRef) {
    const extensionCreatorRef = (0, react_1.useRef)(fn);
    extensionCreatorRef.current = fn;
    const compartmentRef = (0, react_1.useRef)();
    compartmentRef.current ??= new state_1.Compartment();
    const initialExtensionRef = (0, react_1.useRef)();
    initialExtensionRef.current ??= compartmentRef.current.of(extensionCreatorRef.current());
    (0, compass_components_1.useEffectOnChange)(() => {
        if (!editorViewRef.current) {
            return;
        }
        const controller = new AbortController();
        void scheduleDispatch(editorViewRef.current, {
            effects: compartmentRef.current?.reconfigure(extensionCreatorRef.current()),
        }, controller.signal);
        return () => {
            controller.abort();
        };
    }, value);
    return initialExtensionRef.current;
}
const BaseEditor = react_1.default.forwardRef(function BaseEditor({ initialText: _initialText, text, onChangeText, language = 'json', showLineNumbers = true, showFoldGutter = true, showAnnotationsGutter = true, showScroll = true, highlightActiveLine: shouldHighlightActiveLine = true, annotations, completer, darkMode: _darkMode, className, readOnly = false, onLoad = () => {
}, onFocus = () => {
}, onBlur = () => {
}, onPaste = () => {
}, minLines, maxLines, lineHeight = 16, placeholder, commands, initialJSONFoldAll: _initialJSONFoldAll = true, ...props }, ref) {
    const darkMode = (0, compass_components_1.useDarkMode)(_darkMode);
    const onChangeTextRef = (0, react_1.useRef)(onChangeText);
    const onLoadRef = (0, react_1.useRef)(onLoad);
    const onFocusRef = (0, react_1.useRef)(onFocus);
    const onBlurRef = (0, react_1.useRef)(onBlur);
    const onPasteRef = (0, react_1.useRef)(onPaste);
    const initialTextProvided = (0, react_1.useRef)(!!_initialText);
    const initialText = (0, react_1.useRef)(_initialText ?? text);
    const initialLanguage = (0, react_1.useRef)(language);
    const containerRef = (0, react_1.useRef)(null);
    const editorContainerRef = (0, react_1.useRef)(null);
    const editorViewRef = (0, react_1.useRef)();
    const [{ height: contentHeight, hasScroll }, setContentHeight] = (0, react_1.useState)({
        height: 0,
        hasScroll: false,
    });
    const initialJSONFoldAll = (0, react_1.useRef)(_initialJSONFoldAll);
    onChangeTextRef.current = onChangeText;
    onLoadRef.current = onLoad;
    onFocusRef.current = onFocus;
    onBlurRef.current = onBlur;
    onPasteRef.current = onPaste;
    (0, react_1.useImperativeHandle)(ref, () => {
        return {
            foldAll() {
                if (!editorViewRef.current) {
                    return false;
                }
                return foldAll(editorViewRef.current);
            },
            unfoldAll() {
                if (!editorViewRef.current) {
                    return false;
                }
                return (0, language_1.unfoldAll)(editorViewRef.current);
            },
            copyAll() {
                if (!editorViewRef.current) {
                    return false;
                }
                return copyAll(editorViewRef.current);
            },
            prettify() {
                if (!editorViewRef.current) {
                    return false;
                }
                return prettify(editorViewRef.current);
            },
            applySnippet(template) {
                if (!editorViewRef.current) {
                    return false;
                }
                return applySnippet(editorViewRef.current, template);
            },
            focus() {
                if (!editorViewRef.current) {
                    return false;
                }
                editorViewRef.current.focus();
                return true;
            },
            get editorContents() {
                if (!editorViewRef.current) {
                    return null;
                }
                return getEditorContents(editorViewRef.current);
            },
            get editor() {
                return editorViewRef.current ?? null;
            },
        };
    }, []);
    const languageExtension = useCodemirrorExtensionCompartment(() => {
        return [exports.languages[language](), exports.languageName.of(language)];
    }, language, editorViewRef);
    const activeLineExtension = useCodemirrorExtensionCompartment(() => {
        return !readOnly && shouldHighlightActiveLine
            ? [(0, view_1.highlightActiveLine)(), (0, view_1.highlightActiveLineGutter)()]
            : [];
    }, [readOnly, shouldHighlightActiveLine], editorViewRef);
    const readOnlyExtension = useCodemirrorExtensionCompartment(() => {
        return state_1.EditorState.readOnly.of(readOnly);
    }, readOnly, editorViewRef);
    const themeConfigExtension = useCodemirrorExtensionCompartment(() => {
        return themeStyles[darkMode ? 'dark' : 'light'];
    }, darkMode, editorViewRef);
    const lineHeightExtension = useCodemirrorExtensionCompartment(() => {
        return view_1.EditorView.theme({
            '& .cm-scroller': {
                lineHeight: `${lineHeight}px`,
                ...(maxLines &&
                    maxLines < Infinity && {
                    maxHeight: `${maxLines * lineHeight}px`,
                }),
                height: '100%',
                overflowY: 'auto',
            },
            '& .cm-content, & .cm-gutter': {
                ...(minLines && { minHeight: `${minLines * lineHeight}px` }),
            },
        });
    }, [minLines, maxLines, lineHeight], editorViewRef);
    const lineNumbersExtension = useCodemirrorExtensionCompartment(() => {
        return showLineNumbers ? (0, view_1.lineNumbers)() : [];
    }, showLineNumbers, editorViewRef);
    const foldGutterExtension = useCodemirrorExtensionCompartment(() => {
        return showFoldGutter ? createFoldGutterExtension() : [];
    }, showFoldGutter, editorViewRef);
    const shouldShowAnnotationsGutter = showAnnotationsGutter || (annotations && annotations.length === 0);
    const annotationsGutterExtension = useCodemirrorExtensionCompartment(() => {
        return shouldShowAnnotationsGutter ? (0, lint_1.lintGutter)() : [];
    }, shouldShowAnnotationsGutter, editorViewRef);
    const autocompletionExtension = useCodemirrorExtensionCompartment(() => {
        return completer
            ? (0, autocomplete_1.autocompletion)({
                activateOnTyping: true,
                override: [completer],
            })
            : [];
    }, completer, editorViewRef);
    const placeholderExtension = useCodemirrorExtensionCompartment(() => {
        return placeholder ? (0, view_1.placeholder)(placeholder) : [];
    }, placeholder, editorViewRef);
    const commandsExtension = useCodemirrorExtensionCompartment(() => {
        return commands && commands.length > 0 ? view_1.keymap.of(commands) : [];
    }, commands, editorViewRef);
    const updateEditorContentHeight = (0, react_1.useCallback)(() => {
        editorViewRef.current?.requestMeasure({
            read(view) {
                return [
                    view.contentHeight,
                    view.scrollDOM.scrollWidth > view.scrollDOM.clientWidth,
                ];
            },
            write([height, hasScroll]) {
                setContentHeight((state) => {
                    if (height !== state.height || hasScroll !== state.hasScroll) {
                        return { height, hasScroll };
                    }
                    return state;
                });
            },
        });
    }, []);
    (0, react_1.useLayoutEffect)(() => {
        if (!editorContainerRef.current) {
            throw new Error("Can't mount editor: DOM node is missing");
        }
        const domNode = editorContainerRef.current;
        const editor = (editorViewRef.current = new view_1.EditorView({
            doc: initialText.current,
            extensions: [
                state_1.EditorState.tabSize.of(2),
                annotationsGutterExtension,
                lineNumbersExtension,
                foldGutterExtension,
                (0, commands_1.history)(),
                (0, view_1.drawSelection)(),
                (0, language_1.indentOnInput)(),
                (0, language_1.bracketMatching)(),
                (0, autocomplete_1.closeBrackets)(),
                autocompletionExtension,
                languageExtension,
                (0, language_2.syntaxHighlighting)(highlightStyles['light']),
                (0, language_2.syntaxHighlighting)(highlightStyles['dark']),
                activeLineExtension,
                lineHeightExtension,
                themeConfigExtension,
                placeholderExtension,
                commandsExtension,
                view_1.keymap.of([
                    {
                        key: 'Ctrl-Shift-b',
                        run: prettify,
                    },
                    {
                        key: 'Ctrl-Shift-c',
                        run: copyAll,
                    },
                    ...autocomplete_1.closeBracketsKeymap,
                    ...commands_1.defaultKeymap,
                    ...commands_1.historyKeymap,
                    ...language_1.foldKeymap,
                    ...autocomplete_1.completionKeymap,
                    ...tabKeymap,
                ]),
                (0, view_1.tooltips)({
                    parent: document.body,
                }),
                readOnlyExtension,
                view_1.EditorView.updateListener.of((update) => {
                    updateEditorContentHeight();
                    const editorText = editor.state.sliceDoc() ?? '';
                    if (update.docChanged) {
                        onChangeTextRef.current?.(editorText, update);
                    }
                }),
                view_1.EditorView.domEventHandlers({
                    focus(event) {
                        onFocusRef.current?.(event);
                    },
                    blur(event) {
                        onBlurRef.current?.(event);
                    },
                    paste(event) {
                        onPasteRef.current?.(event);
                    },
                }),
            ],
            parent: domNode,
        }));
        domNode._cm = editor;
        onLoadRef.current(editor);
        if (editor && initialLanguage.current === 'json') {
            const docLength = editor.state.doc.length;
            const isSyntaxTreeAvailable = (0, language_1.syntaxTreeAvailable)(editor.state, docLength) ||
                (0, language_1.forceParsing)(editor, docLength, 150);
            if (initialJSONFoldAll.current && isSyntaxTreeAvailable) {
                foldAll(editor);
            }
            else {
            }
        }
        updateEditorContentHeight();
        return () => {
            delete domNode._cm;
            editor.destroy();
        };
    }, [
        annotationsGutterExtension,
        foldGutterExtension,
        languageExtension,
        lineNumbersExtension,
        readOnlyExtension,
        themeConfigExtension,
        autocompletionExtension,
        lineHeightExtension,
        activeLineExtension,
        placeholderExtension,
        commandsExtension,
        updateEditorContentHeight,
    ]);
    (0, react_1.useEffect)(() => {
        if (initialTextProvided.current) {
            return;
        }
        if (editorViewRef.current &&
            text !== (editorViewRef.current.state.sliceDoc() ?? '')) {
            const controller = new AbortController();
            void scheduleDispatch(editorViewRef.current, {
                changes: {
                    from: 0,
                    to: editorViewRef.current.state.doc.length,
                    insert: text,
                },
            }, controller.signal);
            return () => {
                controller.abort();
            };
        }
    }, [text]);
    (0, react_1.useEffect)(() => {
        if (!editorViewRef.current) {
            return;
        }
        const controller = new AbortController();
        void scheduleDispatch(editorViewRef.current, {
            effects: lint_1.setDiagnosticsEffect.of(annotations ?? []),
        }, controller.signal);
        return () => {
            controller.abort();
        };
    }, [annotations]);
    (0, react_1.useLayoutEffect)(() => {
        if (containerRef.current) {
            const scrollHeight = hasScroll && showScroll ? 10 : 0;
            const height = Math.min(contentHeight, (maxLines ?? Infinity) * lineHeight) +
                scrollHeight;
            containerRef.current.style.height = `${height}px`;
        }
    }, [maxLines, contentHeight, hasScroll, lineHeight, showScroll]);
    return (react_1.default.createElement("div", { ref: containerRef, className: className, style: {
            width: '100%',
            minHeight: Math.max(lineHeight, (minLines ?? 0) * lineHeight),
            position: 'relative',
            maxHeight: '100%',
        } },
        react_1.default.createElement("div", { ref: editorContainerRef, className: (0, compass_components_1.cx)(editorStyle, !showScroll && hiddenScrollStyle), style: {
                position: 'absolute',
                width: '100%',
                height: '100%',
            }, "data-codemirror": "true", ...props })));
});
exports.BaseEditor = BaseEditor;
function isTopNode(node) {
    return !node
        ? true
        : node.name === 'Array' || node.name === 'Property'
            ? false
            : node.name === 'JsonText'
                ? true
                : isTopNode(node.parent);
}
const applySnippet = (editor, template) => {
    if (isReadOnly(editor.state)) {
        return false;
    }
    const completion = (0, autocomplete_1.snippetCompletion)(template, { label: template });
    if (typeof completion.apply === 'function') {
        completion.apply(editor, completion, 0, editor.state.doc.length);
        return true;
    }
    else {
        return false;
    }
};
const getEditorContents = (editor, from, to) => {
    return editor.state.sliceDoc(from, to) ?? '';
};
const foldAll = (editor) => {
    const foldableProperties = [];
    (0, language_1.syntaxTree)(editor.state).iterate({
        enter(nodeRef) {
            if (['{', '['].includes(String(nodeRef.name)) &&
                (0, language_1.foldable)(editor.state, nodeRef.from, nodeRef.to) &&
                !isTopNode(nodeRef.node)) {
                if (!nodeRef.node.parent) {
                    throw new Error('Trying to fold node without parent');
                }
                const range = (0, language_1.foldInside)(nodeRef.node.parent);
                if (range) {
                    foldableProperties.push(range);
                }
                return false;
            }
        },
    });
    if (foldableProperties.length > 0) {
        void scheduleDispatch(editor, {
            effects: foldableProperties.map((range) => {
                return language_1.foldEffect.of(range);
            }),
        });
    }
    return !!foldableProperties.length;
};
const copyAll = (editorView) => {
    void navigator.clipboard.writeText(editorView.state.sliceDoc());
    return true;
};
const prettify = (editorView) => {
    if (isReadOnly(editorView.state)) {
        return false;
    }
    const language = editorView.state.facet(exports.languageName)[0];
    const doc = editorView.state.sliceDoc();
    try {
        const formatted = (0, prettify_1.prettify)(doc, language);
        if (formatted !== doc) {
            void scheduleDispatch(editorView, {
                changes: {
                    from: 0,
                    to: editorView.state.doc.length,
                    insert: formatted,
                },
                scrollIntoView: true,
            });
            return true;
        }
    }
    catch {
    }
    return false;
};
const inlineStyles = (0, compass_components_1.css)({
    '& .cm-editor': {
        backgroundColor: 'transparent',
    },
});
const InlineEditor = react_1.default.forwardRef(function InlineEditor({ className, ...props }, forwardRef) {
    return (react_1.default.createElement(BaseEditor, { ref: forwardRef, maxLines: 10, showFoldGutter: false, showLineNumbers: false, showAnnotationsGutter: false, showScroll: false, highlightActiveLine: false, className: (0, compass_components_1.cx)(inlineStyles, className), language: "javascript-expression", ...props }));
});
exports.CodemirrorInlineEditor = InlineEditor;
const multilineEditorContainerStyle = (0, compass_components_1.css)({
    position: 'relative',
    height: '100%',
    backgroundColor: exports.editorPalette.light.backgroundColor,
    [`&:focus-within > .multiline-editor-actions,
    &:hover > .multiline-editor-actions`]: {
        display: 'flex',
    },
});
const multilineEditorContainerWithActionsStyle = (0, compass_components_1.css)({
    minHeight: compass_components_1.spacing[5] - 2,
});
const multilineEditorContainerDarkModeStyle = (0, compass_components_1.css)({
    backgroundColor: exports.editorPalette.dark.backgroundColor,
});
const actionsContainerStyle = (0, compass_components_1.css)({
    position: 'absolute',
    top: compass_components_1.spacing[1],
    right: compass_components_1.spacing[2],
    display: 'none',
    gap: compass_components_1.spacing[2],
});
const MultilineEditor = react_1.default.forwardRef(function MultilineEditor({ customActions, copyable = true, formattable = true, className, editorClassName, actionsClassName, darkMode: _darkMode, ...props }, ref) {
    const darkMode = (0, compass_components_1.useDarkMode)(_darkMode);
    const containerRef = (0, react_1.useRef)(null);
    const editorRef = (0, react_1.useRef)(null);
    (0, react_1.useImperativeHandle)(ref, () => {
        return {
            foldAll() {
                return editorRef.current?.foldAll() ?? false;
            },
            unfoldAll() {
                return editorRef.current?.unfoldAll() ?? false;
            },
            copyAll() {
                return editorRef.current?.copyAll() ?? false;
            },
            prettify() {
                return editorRef.current?.prettify() ?? false;
            },
            focus() {
                return editorRef.current?.focus() ?? false;
            },
            applySnippet(template) {
                return editorRef.current?.applySnippet(template) ?? false;
            },
            get editorContents() {
                return editorRef.current?.editorContents ?? null;
            },
            get editor() {
                return editorRef.current?.editor ?? null;
            },
        };
    }, []);
    const actions = (0, react_1.useMemo)(() => {
        return [
            copyable && (react_1.default.createElement(actions_1.ActionButton, { key: "Copy", label: "Copy", icon: "Copy", onClick: () => {
                    return editorRef.current?.copyAll() ?? false;
                } })),
            formattable && (react_1.default.createElement(actions_1.ActionButton, { key: "Format", label: "Format", icon: react_1.default.createElement(actions_1.FormatIcon, { size: 14, role: "presentation" }), onClick: () => {
                    return editorRef.current?.prettify() ?? false;
                } })),
            ...(customActions ?? []).map((action) => {
                return (react_1.default.createElement(actions_1.ActionButton, { key: action.label, icon: action.icon, label: action.label, onClick: () => {
                        if (!editorRef.current?.editor) {
                            return false;
                        }
                        return action.action(editorRef.current.editor);
                    } }));
            }),
        ];
    }, [copyable, formattable, customActions]);
    return (react_1.default.createElement("div", { ref: containerRef, className: (0, compass_components_1.cx)(multilineEditorContainerStyle, darkMode && multilineEditorContainerDarkModeStyle, !!actions.length && multilineEditorContainerWithActionsStyle, className), onClick: (evt) => {
            if (evt.target === containerRef.current) {
                editorRef.current?.focus();
            }
        } },
        react_1.default.createElement(BaseEditor, { ref: editorRef, className: editorClassName, language: "javascript-expression", minLines: 10, ...props }),
        actions.length > 0 && (react_1.default.createElement("div", { className: (0, compass_components_1.cx)('multiline-editor-actions', actionsContainerStyle, actionsClassName) }, actions))));
});
exports.CodemirrorMultilineEditor = MultilineEditor;
async function setCodemirrorEditorValue(element, text) {
    if (typeof element === 'string') {
        element = document.querySelector(`[data-testid="${element}"]`);
    }
    if (!element || !element.hasAttribute('data-codemirror')) {
        throw new Error('Cannot find editor container');
    }
    const editorView = element._cm;
    await scheduleDispatch(editorView, {
        changes: {
            from: 0,
            to: editorView.state.doc.length,
            insert: text,
        },
    });
}
exports.setCodemirrorEditorValue = setCodemirrorEditorValue;
function getCodemirrorEditorValue(element) {
    if (typeof element === 'string') {
        element = document.querySelector(`[data-testid="${element}"]`);
    }
    const editorView = element?._cm ?? element?.cmView?.view;
    if (!editorView) {
        throw new Error('Cannot find editor container');
    }
    return getEditorContents(editorView);
}
exports.getCodemirrorEditorValue = getCodemirrorEditorValue;
//# sourceMappingURL=editor.js.map